unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    txtBytes: TEdit;
    Label1: TLabel;
    txtFileName: TEdit;
    Label2: TLabel;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
   if OpenDialog1.execute then
      txtFileName.text := OpenDialog1.filename;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
     buff_size = 4096 ;
var
   i, intInputFileHandle, intOutputFileHandle, intBytesRead: integer ;
   buff: array[0..buff_size] of char ;
   randbuff: array[0..1] of char;
   txtOutputFileName: string;
begin
     // open input file
     intInputFileHandle := FileOpen(txtFileName.text, 0) ;
     if intInputFileHandle = -1 then
     begin
          ShowMessage('Cannot open ' +  txtFileName.text);
          Exit ;
     end ;

     // construct the name of the new output file
     txtOutputFileName := ExtractFilePath(txtFileName.text) + '_' + ExtractFileName(txtFileName.text);

     // open output file
     intOutputFileHandle := FileCreate(txtOutputFileName) ;
     if intOutputFileHandle = -1 then
     begin
          ShowMessage('Cannot create _' +  txtOutputFileName);
          Exit ;
     end ;

     // copy input file to output file
     repeat
          intBytesRead := FileRead(intInputFileHandle, buff, SizeOf(buff)) ;
          if intBytesRead > 0 then FileWrite(intOutputFileHandle, buff, intBytesRead) ;
     until intBytesRead = 0 ;

     // close input file
     FileClose(intInputFileHandle) ;

     // now append random bytes to the end of the output file
     // we could just write zeroes but this would probably leave the hash identical to the original program
     Randomize;
     for i := 1 to strtoint(txtBytes.text) do
     begin
        randbuff[0] := chr(random(255));
        FileWrite(intOutputFileHandle, randbuff, 1);
     end;

     // close output file
     FileClose(intOutputFileHandle) ;

     // all done!
     showmessage('Created ' + txtOutputFileName);

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   txtFileName.setFocus;
end;

end.
